import c4d
import os
from c4d import bitmaps, gui, plugins
import json

# be sure to use a unique ID obtained from www.plugincafe.com
PLUGIN_ID = 5554443  # just a test ID

# ID's
PY_MORPH_LINK = 10000
PY_TRANSCRIPT_LINK = 10001
PY_SYNC_START = 10018
PY_LOAD_TRANSCRIPT = 10021


# The Plugin Class
class TestTrans(plugins.TagData):

    def __init__(self):
        # super(plugins.TagData, self)

        self.data = None

    def Init(self, node):

        self.InitAttr(node, c4d.BaseList2D, PY_MORPH_LINK)
        # node[PY_MORPH_LINK] = None

        self.InitAttr(node, str, PY_TRANSCRIPT_LINK)
        # node[PY_TRANSCRIPT_LINK] = ""

        self.InitAttr(node, c4d.BaseTime, PY_SYNC_START)
        node[PY_SYNC_START] = c4d.BaseTime()

        return True

    # def Draw(self, tag, op, bd, bh):
    #     return True
    def load_transcript(self, op):

        if op[PY_TRANSCRIPT_LINK] != "":
            with open(op[PY_TRANSCRIPT_LINK], "r") as transfile:
                self.data = json.load(transfile)

    def move2(self, tag, frame, value):
        print("2. Hello in function")

    def Execute(self, tag, doc, op, bt, priority, flags):

        if self.data:

            pose_morph = tag[PY_MORPH_LINK]

            if not pose_morph:
                return c4d.EXECUTIONRESULT_OK

            morph_count = pose_morph.GetMorphCount()
            print(pose_morph)
            print(self.data["words"])

            frame = doc.GetTime().GetFrame(doc.GetFps()) - tag[PY_SYNC_START]  #Here it is crashing
            print(frame)

            if frame == 10:
                print("1. Hello")

            self.move2(tag, frame, 1)

        return c4d.EXECUTIONRESULT_OK

    # def Execute(self, tag, doc, op, bt, priority, flags):
    #     print(self.data)
    #
    #     return c4d.EXECUTIONRESULT_OK

    def GetDEnabling(self, node, id, t_data, flags, itemdesc):

        return True

    def Message(self, node, type, data):

        if type == c4d.MSG_DESCRIPTION_COMMAND:

            if data["id"][0].id == PY_LOAD_TRANSCRIPT:
                self.load_transcript(node)

        if type == c4d.MSG_DESCRIPTION_POSTSETPARAMETER:
            if data["descid"][0].id == PY_TRANSCRIPT_LINK:
                print("POSTSETPARAMETER")
                self.load_transcript(node)

        return True


# main
if __name__ == "__main__":
    # load icon.tif from res into bmp
    bmp = bitmaps.BaseBitmap()
    dir, file = os.path.split(__file__)
    fn = os.path.join(dir, "res", "icon.tif")
    bmp.InitWith(fn)

    new_bmp = c4d.bitmaps.InitResourceBitmap(1051133)

    # register the plugin
    c4d.plugins.RegisterTagPlugin(id=PLUGIN_ID,
                                  str="Test-Trans",
                                  info=c4d.TAG_EXPRESSION | c4d.TAG_VISIBLE,
                                  description="testtrans",
                                  g=TestTrans, icon=bmp)
